using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.IO;
using System.Text;
using System.Windows.Forms;

using Syncfusion.DLS;
using Syncfusion.Pdf;
using Syncfusion.Pdf.DLS;

using Microsoft.Office.Interop.Word;

namespace Mat.Test.WinApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            
        }
        public void CreatePDF(string pdfText)
        {
            //create a PDF document
            PDFLogicDocument myPDF = new PDFLogicDocument();
            
            Image bgPic = Image.FromFile(@"..\..\borderPic.bmp");
            //myPDF.BackgroundImage = bgPic;
            
            //add a section to the document.
            IPDFSection section = myPDF.AddSection();
            
            //load the image. (have to go back an extra two levels, not sure why?)
            Image img = Image.FromFile(@"..\..\..\..\PdfFrontLogo.gif");

            //add a paragraph to the section
            IPDFParagraph imageParagraph = section.AddParagraph();
            
            //insert image to paragraph
            IPDFPicture picture = imageParagraph.AppendPicture(img);
            picture.Width = 402;
            picture.Height = 112;

            //add a paragraph to the section
            IParagraph paragraph = section.AddParagraph();

            //filling the paragraph
            paragraph.AppendText(pdfText);

            //save the document to disk(?)
            myPDF.Save("matsPDF.pdf");

            PDFDocument myDoc = new PDFDocument(myPDF);
            IPDFGraphicState mygs = myDoc.CreateGraphicState();
            mygs.BorderSize.All = 3;
            mygs.BorderColors.All = Color.Blue;

            myDoc.Save("matsPDF.pdf");

            //messagebox confirmation to show the pdf document.
            if (MessageBox.Show("Do you want to view the PDF file?", "PDF file created", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
            {
                //launch the pdf file with the default app (Acrobat reader)
                System.Diagnostics.Process.Start("matsPDF.pdf");
                this.Close();
            }
            else
            {
                //exit
                this.Close();
            }
        }
        public string ReadDoc(string fileName)
        {
            object file = fileName;
            object nullobj = System.Reflection.Missing.Value;
            object falseobj = false;
            
            ApplicationClass testApp = new ApplicationClass();
            testApp.Visible = false;
            Microsoft.Office.Interop.Word.Document doc2 = testApp.Documents.Open(ref file, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj);
            doc2.Select();
            testApp.Selection.Copy();

            Paragraphs myParagraphs = doc2.Paragraphs;
            long pgCount = myParagraphs.Count;
            StringBuilder sb = new StringBuilder();
            for (int i = 1; i <= pgCount; i++)
            {
                Microsoft.Office.Interop.Word.Paragraph indParagraph = myParagraphs[i];
                Range range = indParagraph.Range;
                string text = range.Text;
                if (textBox2.Text != "")
                {
                    if (i == int.Parse(textBox2.Text))
                    {
                        sb.Append(text);
                    }
                }
                else
                {
                    sb.Append(text);
                }
            }
            doc2.Close(ref falseobj, ref nullobj, ref nullobj);
            testApp.Quit(ref nullobj, ref nullobj, ref nullobj);
            return sb.ToString();
        }
        public void ShowDocText()
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.InitialDirectory = "c:\\";
            openFileDialog1.Filter = "Word files (*.doc)|*.doc|All files(*.*)|*.*";
            openFileDialog1.FilterIndex = 2;
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                string fileName = openFileDialog1.FileName;
                //textBox1.Text = ReadDoc(fileName);
                string pdfText = ReadDoc(fileName);
                CreatePDF(pdfText);
            }
            else if (openFileDialog1.ShowDialog() == DialogResult.Cancel)
            {
                label1.Text = "You clicked Cancel!";
            }
            else
            {
                label1.Text = "File does not exist or is not a Word document!";
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            ShowDocText();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //CreatePDF();
        }
    }
}